/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"
/* ##BEGIN##, 10/22/1991, ZEKI */
#include "string.h"
find_array_in_expr (expr, name)  /* finds array name in expression */
Node *expr;
char *name;
{
	Node *a1, *op, *a2, *sub, *temp;
	int is = 0;
	T_Entry *entry;

	if (expr == NN)
		return 1;

	switch (expr->com.type) {

	case INTEGER_CONSTANT:
	        is = 1;
		break;

	case NAME:
		if ((entry = lookup_loc (expr->com.str)) != TN) {

                                            
			if (IS_parameter (entry))
				is = find_array_in_expr (ENTRY_VALUE (entry), name);
			if (IS_intrinsic (entry)) {
				syserr ("implement");
			}
		}
		break;

	case DUM_EXPR:
		a1 = expr->DumExpr.Expr;
		op = expr->DumExpr.Op;
		a2 = expr->DumExpr.Expr1;

		if (a1 == NN) {  /* unary expr */
			is = find_array_in_expr (a2, name);


		}
		else if (a2 == NN) {
			is = find_array_in_expr  (a1, name);
		}
		else {  /* binary expr */
 
			if (find_array_in_expr  (a1, name)
			&&  find_array_in_expr  (a2, name)) {
				is = 1;

			}
		}

		break;

	case PRIMARY:
		if (expr->Primary.Lp != NN)  /* then is '(' Expr ')' */
			is = find_array_in_expr  (expr->Primary.Expr, name);
		else
			syserr ("implement");
		break;

	case VARIABLE:
		is = find_array_in_expr  (expr->Variable.Name, name);
		break;
	case ARRAY_SECTION:

/* next if catches i.e. $arr_desc which size (arr) becomes an ARRAY_SECTION when
   processing it at compile time */

		if ((entry = lookup_loc (expr->com.str)) == TN)
			break;

		if (IS_constant (entry) || IS_parameter (entry))
			is = 1;
		else
			is = 0;
                if(IS_array(entry)){
                  strcpy(name, entry->orig_name);
		  }
		break;

	default:
		is = 0;  /*!!! saves parameter (param = ... problems */
		break;
	}

	return is;
}
/* ##END##, 10/22/1991, ZEKI */



/* ##BEGIN##, 02/23/1992, ZEKI */

/* This function of this procedure lhs=rhs is to find output_of_intrinsic
   temporary at rhs and set its type and shape as same shape of lhs       */

/* this routine is called  at parse_AssignmentStmt  */
void find_output_of_intrinsic (expr, var)
Node *expr;
Node *var;
{
        Node *a1, *op, *a2, *sub, *temp, *decl;
        T_Entry *entry, *var_entry;
        int i;
        if (expr == NN)
                return ;

        switch (expr->com.type) {

        case INTEGER_CONSTANT:
                break;

	      case NAME:
                if ((entry = lookup_loc (expr->com.str)) != TN) {
                        if (IS_parameter (entry))
                                find_output_of_intrinsic (ENTRY_VALUE (entry), var);
                        if (IS_intrinsic (entry)) {
                                syserr ("implement");
			      }
		      }
                break;

	      case DUM_EXPR:
                a1 = expr->DumExpr.Expr;
                op = expr->DumExpr.Op;
                a2 = expr->DumExpr.Expr1;

                if (a1 == NN) {  /* unary expr */
                        find_output_of_intrinsic (a2, var);


		      }
                else if (a2 == NN) {
                        find_output_of_intrinsic  (a1, var);
		      }
                else {  /* binary expr */

                        find_output_of_intrinsic (a1, var);
                        find_output_of_intrinsic (a2, var);
		      }

                break;
	      case PRIMARY:
                if (expr->Primary.Lp != NN)  /* then is '(' Expr ')' */
                        find_output_of_intrinsic (expr->Primary.Expr, var);
                else
                        syserr ("implement");
                break;

	      case VARIABLE:
                find_output_of_intrinsic (expr->Variable.Name, var);
                break;
	      case ARRAY_SECTION:

/* next if catches i.e. $arr_desc which size (arr) becomes an ARRAY_SECTION when
   processing it at compile time */

                if ((entry = lookup_loc (expr->com.str)) == TN)
                        break;


                if(IS_output_of_intrinsic(entry)){
                  var_entry = lookup_loc(var->com.str);
                  entry->typ = var_entry->typ;
                  entry->local_shape = var_entry->local_shape;  /** BOZKUS **/

                 if(var_entry->typ->shape !=SN)
                     for(i=0; i< var_entry->typ->shape->rank; i++) 
                         entry->dist_style[i] = var_entry->dist_style[i];
                  entry->attr_aligned = var_entry->attr_aligned;
                  entry->align_template = var_entry->align_template;
                  entry->indexlist = var_entry->indexlist;
                  entry->template_indexlist = var_entry->template_indexlist;
                  entry->attr_alloc_temp = 0;
/*                  entry->attr_assumed_pass =0;*/
                  entry->attr_automatic = 0;
                  expr->com.typ = var->com.typ; 
                  if(IS_aligned(var_entry)){
                         decl = align_decl(entry);
                         U_stack_push_arrays ( decl);
		       }
		}
                break;

	      default:
                       /*!!! saves parameter (param = ... problems */
                break;
	      }

        return ;
      }
/* ##END##, 02/23/1992, ZEKI */


expr_is_constant_int (expr, value)  /* finds out if expresion is a constant + R. value */
Node *expr;
long *value;
{
	Node *a1, *op, *a2, *sub, *temp;
	int is = 0;
	T_Entry *entry;

	if (expr == NN)
		return 1;

	switch (expr->com.type) {

	case INTEGER_CONSTANT:
	{
		sscanf (expr->com.str, "%d", value);
	}
		is = 1;
		break;

	case NAME:
		if ((entry = lookup_loc (expr->com.str)) != TN) {
			if (IS_parameter (entry))
				is = expr_is_constant_int (ENTRY_VALUE (entry), value);
			if (IS_intrinsic (entry)) {
				syserr ("implement");
			}
		}
		break;

	case DUM_EXPR:
		a1 = expr->DumExpr.Expr;
		op = expr->DumExpr.Op;
		a2 = expr->DumExpr.Expr1;

		if (a1 == NN) {  /* unary expr */
			is = expr_is_constant_int (a2, value);

			switch (op->com.type) {

			case MINUS:
				*value = - (*value);
				break;
			}
		}
		else if (a2 == NN) {
			is = expr_is_constant_int (a1, value);
		}
		else {  /* binary expr */
			long value1, value2;
 
			if (expr_is_constant_int (a1, &value1)
			&&  expr_is_constant_int (a2, &value2)) {
				is = 1;

				switch (op->com.type) {

				case PLUS:
					*value = value1 + value2;
					break;

				case MINUS:
					*value = value1 - value2;
					break;

				case TIMES:
					*value = value1 * value2;
					break;

				case SLASH:
					*value = value1 / value2;
					break;

				default:
					is = 0;
					break;
				}
			}
		}

		break;

	case PRIMARY:
		if (expr->Primary.Lp != NN)  /* then is '(' Expr ')' */
			is = expr_is_constant_int (expr->Primary.Expr, value);
		else
			syserr ("implement");
		break;

	case VARIABLE:
		is = expr_is_constant_int (expr->Variable.Name, value);
		break;

	default:
		is = 0;  /*!!! saves parameter (param = ... problems */
		break;
	}

	return is;
}

expr_is_constant (expr, value)  /* finds out if expresion is a constant + R. value */
Node *expr;
double *value;
{
	Node *a1, *op, *a2, *sub, *temp;
	int is = 0;
	T_Entry *entry;

	if (expr == NN)
		return 1;

	switch (expr->com.type) {

	case BINARY_CONSTANT:
	case CHARACTER_CONSTANT:
	case HEX_CONSTANT:
	case INTEGER_CONSTANT:
	{
		int ivalue;
		sscanf (expr->com.str, "%d", &ivalue);
		*value = ivalue;
	}
		is = 1;
		break;

	case LOGICAL_CONSTANT:
	case OCTAL_CONSTANT:
	case REAL_CONSTANT:
		sscanf (expr->com.str, "%lf", value);
	case COMPLEX_LITERAL_CONSTANT:
		is = 1;
		break;

	case NAME:
		if ((entry = lookup_loc (expr->com.str)) != TN) {
			if (IS_parameter (entry))
				is = expr_is_constant (ENTRY_VALUE (entry), value);
			if (IS_intrinsic (entry)) {
				syserr ("implement");
			}
		}
		break;

	case DUM_EXPR:
		a1 = expr->DumExpr.Expr;
		op = expr->DumExpr.Op;
		a2 = expr->DumExpr.Expr1;

		if (a1 == NN) {  /* unary expr */
			is = expr_is_constant (a2, value);

			switch (op->com.type) {

			case MINUS:
				*value = - (*value);
				break;
			}
		}
		else if (a2 == NN) {
			is = expr_is_constant (a1, value);
		}
		else {  /* binary expr */
			double value1, value2;
 
			if (expr_is_constant (a1, &value1)
			&&  expr_is_constant (a2, &value2)) {
				is = 1;

				switch (op->com.type) {

				case PLUS:
					*value = value1 + value2;
					break;

				case MINUS:
					*value = value1 - value2;
					break;

				case TIMES:
					*value = value1 * value2;
					break;

				case SLASH:
					*value = value1 / value2;
					break;
				}
			}
		}

		break;

	case PRIMARY:
		if (expr->Primary.Lp != NN)  /* then is '(' Expr ')' */
			is = expr_is_constant (expr->Primary.Expr, value);
		else
			syserr ("implement");
		break;

	case ARRAY_CONSTRUCTOR:
		is = ac_is_constant (expr);
		break;

	case ARRAY_SECTION:

/* next if catches i.e. $arr_desc which size (arr) becomes an ARRAY_SECTION when
   processing it at compile time */

		if ((entry = lookup_loc (expr->com.str)) == TN)
			break;

		if (IS_constant (entry) || IS_parameter (entry))
			is = 1;
		else
			is = 0;
		break;

	case VARIABLE:
		is = expr_is_constant (expr->Variable.Name, value);
		break;

	case FUNCTION_REFERENCE:
		if ((entry = lookup_glo (expr->FunctionReference.Name->com.str)) != TN
		&& IS_intrinsic (entry)
		&& expr_is_constant (expr->FunctionReference.SubscriptList, value)) {
			is = 1;
			*value = 777;  /*!!! fix */
		}
		else
			is = 0;
		break;

	case SUBSCRIPT_LIST:
		if (expr_sublist_not_constant (expr)) {
			is = 0;
		}
		else {
			is = 1;
			*value = 777;  /*!!! fix */
		}
		break;

	default:
		is = 0;  /*!!! saves parameter (param = ... problems */
		break;
	}

	return is;
}

int expr_sublist_not_constant (sublist)  /* finds out if sublist is not a constant */
Node *sublist;
{
	Node *sub, *temp;
	double value;
	int ret = 0;

	if (sublist == NN)
		return ret;

	for (LIST_LOOP (sub, sublist, temp))
		if (!expr_is_constant (sub->Subscript.Expr, &value)
		 || !expr_is_constant (sub->Subscript.Expr1, &value)
		 || !expr_is_constant (sub->Subscript.Expr2, &value))
			ret = 1;

	return ret;
}

int expr_shape_not_constant (shape)
Shape *shape;
{
	double value;
	int i, ret = 0;

	if (shape == (Shape*) 0) 
		return ret;

	for (i = 0; i < shape->rank; i++)
		if (!expr_is_constant (shape->sizes0 [i], &value)
		||  !expr_is_constant (shape->sizes1 [i], &value)
		||  !expr_is_constant (shape->sizes2 [i], &value))
			ret = 1;

	return ret;
}

Node *parse_Primary (root)
Node *root;
{
	if (root->Primary.Lp != NN)
		root->com.typ = root->Primary.Expr->com.typ;

	return root;
}

write_ComplexLiteralConstant (node)
Node *node;
{
	se_in_ComplexLiteralConstant++;
	ochl (node);
	se_in_ComplexLiteralConstant--;
}
	
write_DumExpr (node)
Node *node;
{
	long value = 0;

	if (se_in_ComplexLiteralConstant  /* SUN gives error on (1, (-1)) */
	|| (node->com.typ != (Typ*) 0  /* assumes INTEGER if typ == (nil) */
		&&  node->com.typ->etype->type != TYP_INTEGER)
	||	tree_has (node, NAME))  /* i.e. parameter */
		ochl (node);
	else if (expr_is_constant_int (node, &value)) {
		if (-10000000 < value && value < 10000000) {
			if (value < 0)
				oLP ();

			oint (value);

			if (value < 0)
				oRP ();
		}
		else {
			ochl (node);
		}
	}
	else
		ochl (node);
}
